-- Original version: Simon Thompson

module Coding ( code, decode )
      where

import HTypes ( HTree ( Leaf, Node ), Bit ( L, R ), HCode, HTable )

code :: HTable -> [Char] -> HCode
code htable = concat . map (lookup htable)
              where
              lookup :: HTable -> Char -> HCode
              lookup [] c = error "lookup..."
              lookup ((ch,n):rtable) c | ch==c  = n
                                       | otherwise = lookup rtable c

decode :: HTree -> HCode -> [Char]
decode htree = decodeByte htree
               where
                 decodeByte (Node n t1 t2) (L:rest) = decodeByte t1 rest
                 decodeByte (Node n t1 t2) (R:rest) = decodeByte t2 rest
                 decodeByte (Leaf c n) rest = c:decodeByte htree rest
                 decodeByte t [] = []

