-- Original version: Simon Thompson

module Frequency (frequency) -- [Char] -> [(Char,Int)]
      where

-- general merge sort whisch uses two sort functions

mergeSort :: ([a]->[a]->[a])-> [a] -> [a]
mergeSort merge xs | (length xs < 2) = xs
                   | otherwise     = merge (mergeSort merge first)
                                           (mergeSort merge second)
                                     where
                                        first = take half xs
                                        second = drop half xs
                                        half = (length xs) `div`2

-- in sorting the characters, we amalgamate entries for the same charaters

alphaMerge :: [(Char, Int)] -> [(Char,Int)] -> [(Char,Int)]
alphaMerge xs [] = xs
alphaMerge [] ys = ys
alphaMerge ((p,n):xs) ((q,m):ys)
           | (p==q)   = (p,n+m) : alphaMerge xs ys
           | (p<q)    = (p,n) : alphaMerge xs ((q,m):ys)
           | otherwise = (q,m) : alphaMerge ((p,n):xs) ys

-- when two pairs have the same frequency
-- we order according to the character ordering

freqMerge :: [(Char, Int)] -> [(Char,Int)] -> [(Char,Int)]
freqMerge xs [] = xs
freqMerge [] ys = ys
freqMerge ((p,n):xs) ((q,m):ys)
           | (n<m || (n==m && p<q)) = (p,n) : freqMerge xs ((q,m):ys)
           | otherwise = (q,m) : freqMerge ((p,n):xs) ys

frequency :: [Char] -> [(Char,Int)]
frequency = mergeSort freqMerge . mergeSort alphaMerge . map start
            where
             start ch = (ch,1)

start ch = (ch,1)