-- Original version: Simon Thompson

module HTypes (
                HTree (Leaf, Node),
                Bit ( L, R ),
                HCode,
                HTable
              )
        where

data Bit = L | R 
               deriving (Eq, Show)

type HCode = [Bit]

-- in the translation we convert the Huffman tree to a table 

type HTable = [ (Char, HCode) ]

-- The Huffman trees carry characters at the leaves
-- and frequencies at the internal nodes.

data HTree = Leaf Char Int | Node Int HTree HTree
          deriving (Show)
