-- module for testing

module Main where

import HTypes ( HTree(Leaf,Node), Bit(L,R), HCode, HTable )
import Coding ( code, decode )
import MakeCode ( codes, codeTable )
import Frequency ( frequency )
import MakeTree( makeTree, toTreeList )


text = "WELCHE BUCHSTABEN WERDEN IN DER DEUTSCHEN SPRACHE AM HAEUFIGSTEN VERWENDET?"
text_freq = frequency text

htree = makeTree text_freq
htable = codeTable htree

htree_example = Node 10 (Node 20 (Leaf 'a' 3) (Node 30 (Leaf 'b' 6) (Leaf 'c' 3)))
                     (Node 10 (Leaf 'd' 2) (Leaf 'e' 5))

hcode = code htable "BBADDR VWE"
test_decode = decode htree hcode

list_of_trees = toTreeList text_freq 
test_codes = codes text

-- just for testing
-- you can try the exmaples of the slides